//
//  PokemonsViewController.m
//  Demo
//
//  Created by Santiago Pavón on 28/10/13.
//  Copyright (c) 2013 UPM. All rights reserved.
//

#import "PokemonsViewController.h"

#import "PokemonCVCell.h"
#import "PokemonCVHeader.h"

#import "WebViewController.h"

#import "PokedeskModel.h"
#import "Race.h"
#import "Type.h"

@interface PokemonsViewController ()

@property (nonatomic,strong) PokedeskModel* pokedeskModel;

@end

@implementation PokemonsViewController

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view.
    
    self.pokedeskModel = [[PokedeskModel alloc] init];
    
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}


#pragma mark - Collection View Data Source

- (NSInteger) numberOfSectionsInCollectionView:(UICollectionView *)collectionView
{
    return [self.pokedeskModel.types count];
}

- (NSInteger) collectionView:(UICollectionView *)collectionView
      numberOfItemsInSection:(NSInteger)section
{
    Type * type = self.pokedeskModel.types[section];
    return [type.races count];
}

- (UICollectionViewCell *)collectionView:(UICollectionView *)collectionView
                  cellForItemAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString * cellId = @"PokemonCell";
    
    PokemonCVCell * cell = [collectionView dequeueReusableCellWithReuseIdentifier:cellId
                                                                   forIndexPath:indexPath];
    
    NSInteger section = indexPath.section;
    NSInteger item = indexPath.item;
    
    Type * type = self.pokedeskModel.types[section];
    Race * race = type.races[item];
    
    cell.nameLabel.text = race.name;
    cell.iconImageView.image = [UIImage imageNamed:race.icon];
    
    
    return cell;
}

-(UICollectionReusableView *)collectionView:(UICollectionView *)collectionView
          viewForSupplementaryElementOfKind:(NSString *)kind
                                atIndexPath:(NSIndexPath *)indexPath
{
    if ([kind isEqualToString:UICollectionElementKindSectionHeader]) {
        
        PokemonCVHeader *header = [collectionView dequeueReusableSupplementaryViewOfKind:kind
                                                                   withReuseIdentifier:@"TypesHeader"
                                                                          forIndexPath:indexPath];
        Type * type = self.pokedeskModel.types[indexPath.section];
        
        header.nameLabel.text = [type.name capitalizedString];
        header.infoLabel.text = [NSString stringWithFormat:@"%d razas",[type.races count]];
        
        return header;
    }
    
    return nil;
}


#pragma mark - Navigation

// In a story board-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender
{
    if ([segue.identifier isEqualToString:@"Show Web Info"]) {
        
        NSIndexPath * ip = [self.collectionView indexPathForCell:sender];

        WebViewController *wvc = segue.destinationViewController;
        
        Type * type = self.pokedeskModel.types[ip.section];

        wvc.race = type.races[ip.item];
    }
}

@end




















